ROOTDIR=${HOME}/ppp
UTILDIR=${ROOTDIR}/util

USEPGPLOT = -DPGPLOT
PGPLIBS   = -L/usr/X11R6/lib64 -L${PGPLOT_DIR}   -lcpgplot -lpgplot -lX11  -lpng

INCLUDES=-I${UTILDIR} -I${PGPLOT_DIR}

CC=gcc
F77=gfortran
F90=gfortran
CFLAGS=-std=c99 -O3 -Wall ${USEPGPLOT} ${INCLUDES}
FFLAGS=-O3 -Wall ${INCLUDES} -g -fbounds-check
CFLAGS_FAST=-std=c99 -O3 ${USEPGPLOT} ${INCLUDES}
CLIBS=${UTILDIR}/pca_utils.o -lm
LDFLAGS=${UTILDIR}/pca_utils.o -lm

OMPCC=gcc
OMPF77=gfortran
OMPCFLAGS=${CFLAGS} -fopenmp
OMPCFLAGS_FAST = ${CFLAGS_FAST} -fopenmp
OMPFFLAGS=-fopenmp
OMPLDFLAGS=${UTILDIR}/pca_utils.o  ${LDFLAGS} -lgomp

MPICC=mpicc
MPIF90=mpif90
MPIF77=mpif90
MPIUTILS=${UTILDIR}/pca_mpi_utils.o 

BLAS=-L ${SCINET_GOTOBLAS_LIB} -lgoto2 -lgfortran -lpthread -lgomp