
//daxpy_omp
#include <stdio.h>
#include "../util/pca_utils.h"


void daxpy(int n, double a, double *x, double b, double *y)
     /*y[i]-->b*y[i]+a*x[i]*/
{
#pragma omp parallel for shared(n,a,b,x,y) default(none)
  for (int i=0;i<n;i++)
    y[i]=a*x[i]+b*y[i];
}
/*================================================================================*/

int main(int argc, char *argv[])
{
  int n=1e8;
  pca_time tt;
  double *x=vector(n);
  double *y=vector(n);
  for (int i =0;i<n;i++)
    x[i]=i;
  tick(&tt);
  daxpy(n,2.0,x,0.0,y);
  double dt=tocksilent(&tt);
  printf("Took %12.3e seconds to calculate multiplication and sum for %d numbers.\n",dt,n);
}
