#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <omp.h>
#include <assert.h>

#define MAXQUEUE 1000
#define MAXLEN 512
//program to read in a bunch of commands from a text file, and execute them.
int main(int argc, char *argv[])
{
  char *master_queue[MAXQUEUE], line_in[MAXLEN], *tmp;
  int i;
  FILE *infile;


  assert(argc>1);  //we want a file name
  infile=fopen(argv[1],"r");
  i=0;
  //first read all lines from a file in.  Each line will be a separate command.
  while (fgets(line_in,MAXLEN,infile)) {
    int mylen=strlen(line_in);
    tmp=(char *)malloc(sizeof(char)*(mylen+3));  //pad just for safety
    strncpy(tmp,line_in,mylen+2);
    master_queue[i]=tmp;
    i++;
  }
  fclose(infile);
  int n=i;
  //print out our commands.
  for (int i=0;i<n;i++)
    printf("Command %d is %s",i,master_queue[i]);
  printf("\n\nGoing to execute %d commands\n",n);

  //Now, execute all the commands that I have read in.
#pragma omp parallel for schedule(dynamic,1) shared(n,master_queue) default(none)
  for (int i=0;i<n;i++)
    system(master_queue[i]);
}
