#include <stdio.h>
#include "pca_utils.h"
#include <omp.h>

void daxpy(long n,double a,double *x,double *y,double*z) {
#pragma omp parallel default(none) shared(n,a,x,y,z) 
   {
      #pragma omp for
      for (long i=0;i<n;i++) {
         x[i] = (double)i*(double)i;
         y[i] = (double)(i+1.)*(double)(i-1.);
      }
      #pragma omp for
      for (long i=0;i<n;i++)
         z[i] += a*x[i] + y[i];
   }
}
long main(){
   long n=1e7;
   double *x = vector(n);
   double *y = vector(n);
   double *z = vector(n);
   double a = 5./3.;
   pca_time tt;
   tick(&tt);
   daxpy(n,a,x,y,z);
   printf("Element 1001 is %lf \n", z[1001]);
   tock(&tt);
   free(x);
   free(y);
   free(z);
}   
