#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>
#include <mpi.h>
#include "pca_utils.h"


/*--------------------------------------------------------------------------------*/
void  mpitock(pca_time *tt, double *min, double *mean, double *max)
{
  double mytime; 
  pca_time tnow;
  int size;
  gettimeofday(&tnow,NULL);
  mytime =  (tnow.tv_usec-tt->tv_usec)/1.0e6+(tnow.tv_sec-tt->tv_sec);  

  MPI_Allreduce(&mytime, min, 1, MPI_DOUBLE_PRECISION, MPI_MIN, MPI_COMM_WORLD);
  MPI_Allreduce(&mytime, max, 1, MPI_DOUBLE_PRECISION, MPI_MAX, MPI_COMM_WORLD);
  MPI_Allreduce(&mytime, mean, 1, MPI_DOUBLE_PRECISION, MPI_SUM, MPI_COMM_WORLD);
  MPI_Comm_size(MPI_COMM_WORLD, &size);
  *mean /= (1.*size);

  return;
}

void  mpiminmeanmax(int n, int *min, double *mean, int *max)
{
  int isum;
  int size;
  MPI_Allreduce(&n, min, 1, MPI_INT, MPI_MIN, MPI_COMM_WORLD);
  MPI_Allreduce(&n, max, 1, MPI_INT, MPI_MAX, MPI_COMM_WORLD);
  MPI_Allreduce(&n, &isum, 1, MPI_INT, MPI_SUM, MPI_COMM_WORLD);
  MPI_Comm_size(MPI_COMM_WORLD, &size);
  *mean = (1.*isum)/(1.*size);

  return;
}
